// real.cpp : Defines the entry point for the console application.
//

#include <stdio.h>
#include <math.h>
#include <time.h>
#include "../real.h"

using namespace RealLib;

char *sizes[] = {"1e-100", "1e-1000", "1e-2500", "1e-10000", "1e-25000", "1e-100000"}; 
int times[] = {200, 10, 1, 1, 1, 1};

int main(int argc, char* argv[])
{
	char buf[100000];
	clock_t starttime, endtime;
	Initialize(11, 100000);
	FILE *out = fopen("res.txt", "w+t");

	for (int i=0; i<4; ++i)
	{
		Real cmp(sizes[i]);
		Real seven(7);
		int j;

		// warm up
		if (!(seven+seven - seven*2 < cmp)) break;

		#define BENCHOP(x, tm) \
			starttime = clock(); \
			for (j=0; j<times[i]*tm; ++j) { \
				Real z(x); \
				if (!((z)-(z) < cmp)) break; \
			} \
			endtime = clock(); \
			fprintf(out, #x": %lf\n", double(endtime - starttime) / CLOCKS_PER_SEC/ ceil(times[i]*tm)); \
			printf(#x": %lf\n", double(endtime - starttime) / CLOCKS_PER_SEC / ceil(times[i]*tm));

		printf("prec: %s\n", sizes[i]);
		BENCHOP(seven + seven, 500);
		BENCHOP(seven * seven, 100);
		BENCHOP(recip(seven), 10);
		BENCHOP(sqrt(seven), 10);
		BENCHOP(pi(), 1.9);
		BENCHOP(ln2(), 1.8);
		BENCHOP(ln(seven), 0.75);
		BENCHOP(exp(seven), 0.25);
		BENCHOP(atan(seven), 0.4);
		BENCHOP(cos(seven), 0.25);
	}

	fclose(out);
	unsigned pr = Finalize();

	printf("prec: %d\n", pr);

	getchar();
	return 0;
}

