// real.cpp : Defines the entry point for the console application.
//

#include <stdio.h>
#include <math.h>
#include <time.h>
#include "../real.h"
#include "../convolution.h"
#include "../convolution.cpp"

using namespace RealLib;

#define size 4096

int main(int argc, char* argv[])
{
	char buf[100000];
	clock_t starttime, endtime;
	Initialize(11, 100000);

	starttime = clock();

	{
		int i;
		Real a[size], b[size];

		Convolution<Real> conv(size, pi() * 2);

		for (i=0;i<size/2;++i) {
			a[i] = i+1; b[i] = 5+i;
		}
		
		conv.Convolve(a, b);

		for (i=0;i<size-1;++i)
			printf("result[%d]: %lf\n", i, a[i].AsDouble());
	}

	int pr = Finalize();
	endtime = clock();

	printf("prec: %d\n time elapsed: %lf\n", pr, double(endtime - starttime) / CLOCKS_PER_SEC);

	getchar();
	return 0;
}

