#include <stdio.h>
#include <time.h>
#include "../real.h"

using namespace RealLib;

int main(int argc, char* argv[])
{
	char buf[100];
	clock_t starttime = clock();
	Initialize();

	{
		Real ex(exp(Real(1.0)));
		Real s(0.0), m(1.0);

		for (int i=1; i<=1000; ++i) {
			s += m;
			m /= i;
		}

		Real diff(ex - s);

		if (diff > 0.0) {	
			printf("exp(1.0):\t%s\n", ex.AsDecimal(buf, 50));
			printf("taylor:\t%s\n", s.AsDecimal(buf, 50));
			printf("difference:\t%s\n", diff.AsDecimal(buf, 50));
		}

	}

	unsigned pr = Finalize();

	clock_t endtime = clock();
	printf("prec: %d time elapsed: %lf\n", pr, 
double(endtime - starttime) / CLOCKS_PER_SEC);

	getchar();
	return 0;
}
